package account;

/**
 * @author Horst Lichter, Jochen Ludewig Software Engineering  Grundlagen,
 *         Menschen, Prozesse, Techniken, dpunkt.verlag (c) 2023 Defines the
 *         interface of a simple bank account
 */
public interface IAccount {

   /**
    * @param amount to be deposited
    */
   public void deposit(int amount);

   /**
    * @param amount to be withdrawn
    */
   public void withdraw(int amount);

   /**
    * @return the holder of the account
    */
   public String getHolder();

   /**
    * @param newHolder the new account holder
    */
   public void setHolder(String newHolder);

   /**
    * @return the defined overdraft amount
    */
   public int overdraft();

   /**
    * @return the account's balance
    */
   public int balance();
}
