package junit;

import static org.junit.Assert.*;

import org.junit.Test;

import account.AccountImplValid4JBestPractice;

/**
 * Checks the postconditions of the Account methods
 * 
 * @author Horst Lichter, Jochen Ludewig, Software Engineering  Grundlagen,
 *         Menschen, Prozesse, Techniken, dpunkt.verlag, (c) 2023
 */
public class TestAccountImplValid4JBestPractice {

   /**
    * Checks the constructor
    */
   @Test
   public void testAccountCreation() {
      AccountImplValid4JBestPractice acc1 = new AccountImplValid4JBestPractice(5, "Lilly", -1000);
      assertTrue(acc1.invariant()); 
      assertTrue(acc1.getHolder() == "Lilly"); 
      assertTrue(acc1.balance() == 5); 
      assertTrue(acc1.overdraft() == -1000); 

   }

   /**
    * Checks the deposit method
    */
   @Test
   public void testDeposit() {
      AccountImplValid4JBestPractice acc1 = new AccountImplValid4JBestPractice(5, "Lilly", -1000);
      int balanceOld = acc1.balance();
      int amount = 300;
      acc1.deposit(amount);
      assertTrue(acc1.invariant()); 
      assertTrue(acc1.balance() == balanceOld + amount); 
   }

   /**
    * Checks the withdraw method
    */
   @Test
   public void testWithdraw() {
      AccountImplValid4JBestPractice acc1 = new AccountImplValid4JBestPractice(300, "Lilly", -1000);
      int balanceOld = acc1.balance();
      int amount = 1299;
      acc1.withdraw(amount);
      assertTrue(acc1.invariant()); 
      assertTrue(acc1.balance() == balanceOld - amount); 
   }

   /**
    * Checks the setHolder method
    */
   @Test
   public void testSetHolder() {
      AccountImplValid4JBestPractice acc1 = new AccountImplValid4JBestPractice(300, "Lilly", -1000);
      acc1.setHolder("Paul");
      assertTrue(acc1.invariant()); 
      assertTrue(acc1.getHolder() == "Paul"); 

   }

   /**
    * Checks the deposit and then withdraw of the same amount
    */
   @Test
   public void testDepositWithdraw() {
      AccountImplValid4JBestPractice acc1 = new AccountImplValid4JBestPractice(100, "Lilly", -1000);
      int balanceOld = acc1.balance();
      int amount = 200;
      acc1.deposit(amount);
      acc1.withdraw(amount);
      assertTrue(acc1.invariant()); 
      assertTrue(acc1.balance() == balanceOld); 
   }

   /**
    * Checks the withdraw and then deposit of the same amount
    */
   @Test
   public void testWithdrawDeposit() {
      AccountImplValid4JBestPractice acc1 = new AccountImplValid4JBestPractice(300, "Lilly", -1000);
      int balanceOld = acc1.balance();
      int amount = 200;
      acc1.withdraw(amount);
      acc1.deposit(amount);
      assertTrue(acc1.invariant()); 
      assertTrue(acc1.balance() == balanceOld); 
   }

}
